Bug 92773 - Calc file with many hyperlinks slow on FILEOPEN FILESAVE VIEWING
Summary: Calc file with many hyperlinks slow on FILEOPEN FILESAVE VIEWING
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
4.4.1.2 release
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: Markus Mohrhard
URL:
Whiteboard: target:5.2.0
Keywords: bibisected, bisected, perf, regression
Depends on:
Blocks:
 
Reported: 2015-07-15 18:47 UTC by Milos Sramek
Modified: 2017-03-12 07:11 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:


Attachments
ods file with many hyperlinks (1.10 MB, application/vnd.oasis.opendocument.spreadsheet)
2015-07-15 18:47 UTC, Milos Sramek
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Milos Sramek 2015-07-15 18:47:54 UTC
Created attachment 117265 [details]
ods file with many hyperlinks

A file with many hyperlinks (90000) is very slow on loading, saving and scrolling is not smooth - hangs for a while every now and then. It is a regression, it worked well for versions 4.4.0.0.beta1 to 4.1.1.1 - the slowdown is about 200 times.

Detailed statistics, LO versions downloaded from http://downloadarchive.documentfoundation.org/libreoffice/old/

comment,version,build,load,manipulation,save
"last slow",Version: 4.3.7.2, Build ID: 8a35821d8636a03b8bf4e15b48f59794652c68ba,       10 min,clumsy,10 min
"first fast",Version: 4.4.0.0.beta1, Build ID: 9af3d21234aa89dac653c0bd76648188cdeb683e,4 s,smooth,3 s
"last fast",Version: 4.4.1.1, Build ID: b5ac74bf8683a92078a2bc8aff97d4b436af63cb,       4 s,smooth,3 s
"fist slow",Version: 4.4.1.2, Build ID: 45e2de17089c24a1fa810c8f975a7171ba4cd432,       10 min, clumsy, 10 min

I would also bibisect it, but I was not able to find the right git repository to clone. This information is missing in e.g. in https://wiki.documentfoundation.org/QA/Bibisect

Milos
Comment 1 raal 2015-07-16 14:46:23 UTC
I can confirm with Version: 5.1.0.0.alpha1+
Build ID: 9be553f4c61f220ebbe212dc76cb9cce4ae1c106
TinderBox: Linux-rpm_deb-x86_64@46-TDF, Branch:master, Time: 2015-07-13_22:45:19

works OK with Version: 4.4.0.0.alpha2+
Build ID: 3f94c9e9ddfd807b449f3bb9b232cf2041fa12d2
Comment 2 Matthew Francis 2015-08-13 05:16:26 UTC
The below commit appears to be where loading this file started to be slow.
I don't see that Henry Castro has a BZ account, so no way to forward this directly

    commit 5a646f04cc40fb13f39b16ab452237e5cf324684
    Author:     Henry Castro <hcvcastro@gmail.com>
    AuthorDate: Tue Feb 10 18:27:13 2015 -0400
    Commit:     Eike Rathke <erack@redhat.com>
    CommitDate: Thu Feb 12 11:07:09 2015 +0000
    
        fdo#82719  EDITING: String with hyperlink not pasted
    
        Fixed. It is impossible to copy / paste a string with hyperlink what is part of a longer string in cell.
    
        Change-Id: Id97ef7d742ab8ca17e2cafdc449d04d5839e93d4
        Reviewed-on: https://gerrit.libreoffice.org/14412
        Tested-by: Jenkins <ci@libreoffice.org>
        Reviewed-by: Eike Rathke <erack@redhat.com>
        Tested-by: Eike Rathke <erack@redhat.com>
Comment 3 Norbert Thiebaud 2015-08-22 23:32:13 UTC
I confim that reverting the commit 5a646f04cc40fb13f39b16ab452237e5cf324684
on master do put the performance back in 'normal'
and 'slow' does not just describe it.. without the revert I
have a document(sent to the ML by milos sramek) that I basically killed after 5+ minutes cpu trying to load it.
with the revert it load in few seconds...
Comment 4 Robinson Tryon (qubit) 2015-12-13 11:13:25 UTC Comment hidden (obsolete)
Comment 5 Commit Notification 2016-04-10 03:57:55 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=be829fa15777b3b1a6727eee231c89894e7c425e

don't pool SvxFieldItem, tdf#92773

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.